
List<Bigram> processData(int dewey)
{
    int numBigrams = 10;
    ArrayList<Bigram> bigrams = loadData(dewey);
    ArrayList<Bigram> returnedBigrams = new ArrayList<Bigram>();
    int j = 0;
    for (Bigram bi:bigrams)
    {
      if (bi.firstHalf.length() >= 2)
      {
        returnedBigrams.add(bi);
        j++;
      }
      
      
    }
    println(returnedBigrams.size());
    Collections.shuffle(returnedBigrams);
    List<Bigram> returnedRandomBigrams  = returnedBigrams.subList(0, numBigrams);
    
     
     int label = 1;
      for (Bigram bi: returnedRandomBigrams)
      {
        StringBuilder secondHalf = new StringBuilder();
         for (int k = 0; k< bi.secondHalf.length; ++k)
              secondHalf.append(bi.secondHalf[k] +",");
         println(label++ + "-"+bi.firstHalf + ": " + secondHalf.toString());
      }
     
    
    return returnedRandomBigrams;

}






ArrayList<Bigram> loadData(int dewey)
{
  
    ArrayList<Bigram> bigrams = new ArrayList<Bigram>();
    Table table = loadTable("TopBigramDew" + dewey+"_p.csv", "header");
    int rowNums = table.getRowCount();
    
    String oldHalf = table.getString(0, 0);
    ArrayList<String> secondHalfList = new ArrayList<String>();
    
     String firstHalf, secondHalf;
    for (int i = 0; i<rowNums; ++i)
    {
       firstHalf = table.getString(i, 0); 
       secondHalf = table.getString(i, 1); 
      

      if (!firstHalf.equals(oldHalf))
      {
        // Construct a Bigram object for the old bigram
        Bigram bi = new Bigram(oldHalf, secondHalfList.toArray(new String[secondHalfList.size()]));
        bigrams.add(bi);
        // We transitioned into a new firstHalf
        oldHalf = firstHalf;
        secondHalfList.clear();
        secondHalfList = new ArrayList<String>();
      }
      if (secondHalf.length() > 2)
          secondHalfList.add(secondHalf);
      
    }
       // Add the last element
       bigrams.add(new Bigram(oldHalf, secondHalfList.toArray(new String[secondHalfList.size()])));
       return bigrams;

}