void drawAllBigrams()
{
  for (int j = 0; j< 1; ++j)
  {
  for (int i = 0; i< bigrams.get(j).size(); ++i)
    {
      for (int k = 0; k< bigrams.get(j).get(i).secondHalf.length; ++k)
              tryDrawingBigram(bigrams.get(j).get(i), k);
    }
    globalZ-= 50;
  }
}


void tryDrawingBigram(Bigram bi, int j)
{
  // We want to update this function so that it takes a bigram as an input and puts this bigram in an x,y,z poisition
  
    String fName = bi.firstHalf;
    String lName = bi.secondHalf[j];
    float xDis = globalX;
    float yDis = globalY;
    float zDis = globalZ;
    
    textSize(120);
    float textHeight = textAscent() + textDescent();
   // print("text Height is " + textHeight);

    pushMatrix();
    scale(0.1);
    fill(255);
    translate(xDis, yDis, zDis);
    translate(0, -textHeight, 0);
    rect(0, 0, textWidth(fName), textHeight );
    
    popMatrix();
    
    
    pushMatrix();
    scale(0.1);
    fill(255);
    translate(xDis, yDis, zDis);
    translate(0+textWidth(fName), 0 - textHeight, 0);
    rect(0, 0, textWidth(lName), textHeight );
    popMatrix();
    
    
    
    pushMatrix();
    scale(0.1);
    fill(0);
    translate(xDis, yDis, zDis+100);
    text(fName, 0, 0);
    translate(textWidth(fName), 0, 0);
    text(lName, 0 , 0);
    //Update globalX
    globalX += textWidth(fName)+textWidth(lName);
    updateGlobalX();
    popMatrix();
}


void updateGlobalX()
{
  if(globalX >= width) 
    {
      globalX = -width;
      globalY += textAscent() + textDescent();
    }
    
}
/*
void drawDeweyBigramsRect(int dewey)
{
      
      textSize(120);
      pushMatrix();
      fill(0);
      scale(0.1);
      text(deweyTitles[dewey].toUpperCase(), 0, -height + 5);
      
      popMatrix();
      
     
      for (Bigram bi: bigrams.get(dewey))
        {
        
        
        for (String secHalf: bi.secondHalf)
        {
           textSize(120);
           pushMatrix();
           scale(0.05);
           fill(0);
           textAlign(CENTER, CENTER);
           translate(bi.x, bi.y, bi.biZ);
           rect(textWidth(bi.firstHalf)+ textWidth(secHalf), 20, 0, 0);
           text(bi.firstHalf, 0, 0);
           text(secHalf, 0+textWidth(bi.firstHalf),0 );
           popMatrix();
        }
        scale(1/0.05);
      
        
        
      }
    
    
}
*/

void drawDeweyBigrams(int dewey)
{
      float x = -width/2 + horizMargin; //-width/2 + horizMargin + rad/4;
      float y = -height/2 + vertMargin; //-height/2 + vertMargin + rad/4;
      float z = 0;
      
      textSize(120);
      pushMatrix();
      fill(0);
     // translate(0, -height/2 + 100, 0);
      
      translate(18, 0, 0);
      scale(0.1);
      text(deweyTitles[dewey].toUpperCase(), 0, -1.5*height);
      
      popMatrix();
      
      int cnt = 0;
      for (Bigram bi: bigrams.get(dewey))
        {
         
         x = tenPoints[2*cnt];
         y = tenPoints[2*cnt+1];
         
         print("Cnt: " + cnt +"Bi: "+bi.firstHalf  +"@ Ellipse Vertices: " + x + ":" + y);
          
          color c = getFiveShades(cnt)[3];
          color c2 = getFiveShades(cnt++)[4];
          drawEllipses(rad, bi.secondHalf, x, y, z, c, c2,bi.zDisplacements);
          
        textSize(120);
        pushMatrix();
        translate(x, y, z);
        fill(c);
       // ellipse(0, 0, rad/2, rad/2);
        ellipse(0, 0, nodeRad+2, nodeRad+2);
        //popMatrix();
        
        //pushMatrix();
        // Write the text
        scale(0.06);
        fill(0);
        textAlign(CENTER, CENTER);
        //translate(x, y - rad/4, z);
        translate(0, 100, 400);
        text(bi.firstHalf.toUpperCase(), 0, 0);
        scale(1/0.05);
        popMatrix();
        
        
        
       // z-= 20;
      }
    
    
}

void drawEllipses(int rad, String[] text, float x_trans, float y_trans, float z, color c, color c2,float[] zDisplacements)
{
  int N = text.length;
  float thetaText = 0; 
  float thetaIncrementText = (float) 360/N;
  float raduisIncr = 50;
  float zBefore = z;
    
  for( int i = 0; i < N; ++i)
  {
    
    z = zBefore + zDisplacements[i];
    
    pushMatrix();
    stroke(0);
    strokeWeight(5);
    float x = rad * cos(radians(thetaText)+theta)/2;
    float y = rad * sin(radians(thetaText)+theta)/2;
    fill(c);
    stroke(c);
    strokeWeight(1);
   // rotate(theta);
    
   // rotateX(theta);
   // rotateY(theta);
  //  rotateZ(theta);
    
    line(x_trans, y_trans, zBefore, x+x_trans, y+y_trans, z);
    translate(x+x_trans, y+y_trans, z);
   // rotate(theta);
    ellipse(0, 0, nodeRad, nodeRad);
    popMatrix();
    
    
    pushMatrix();
    x = (rad + nodeRad + raduisIncr )* cos(radians(thetaText) + theta)/2;
    y = (rad + nodeRad + raduisIncr)* sin(radians(thetaText) + theta)/2;
    //rotate(theta);
    
    
    translate(x +x_trans, y + y_trans, z);
    
    textSize(7);
    fill(c2);
    //textAlign(RIGHT, RIGHT);
    
    //rotate(theta);
    text(text[i], 0, 0);
    //stroke
    
    
    popMatrix();
    thetaText += thetaIncrementText;
    
    
  }
}

float[] polygon(float x, float y, float radius, int npoints, float z) {
  float[] returnedPoints = new float[npoints*2];
  int index = 0;
  float angle = TWO_PI / npoints;
  beginShape();
  for (float a = 0; a < TWO_PI; a += angle) {
    float sx = x + cos(a) * radius;
    float sy = y + sin(a) * radius;
    vertex(sx, sy, z);
    returnedPoints[index++] = sx;
    returnedPoints[index++] = sy;
   // print("Vertices: " + sx + ":" + sy);
  }
  endShape(CLOSE);
  return returnedPoints;
}

int getOuterPoints(List<Bigram> bigrams)
{
  int pointCount = 0;
  for (Bigram bi: bigrams)
  {
      pointCount += bi.secondHalf.length;
  }
  return pointCount;
}